#!/bin/sh

need-to-build-index ()
{
  ! cmp -s $1.idx $1.idx.old ||
    [ ! $1.ist -ot $1.ind ]
}

need-to-build-dvi ()
{
   ! cmp -s $1.toc $1.toc.old ||
     [ ! $1.latex -ot $1.dvi ] ||
     [ ! $1.ind -ot $1.dvi ]
}

build-index ()
{
  cp $1.idx $1.idx.old
  makeindex -s $1.ist $1.idx
}

build-dvi ()
{
  cp $1.toc $1.toc.old
  latex $1.latex
}

LATEXDOC=meta-cvs

while true ; do
  if need-to-build-dvi $LATEXDOC ; then
    build-dvi $LATEXDOC
    if need-to-build-index $LATEXDOC ; then
      build-index $LATEXDOC
    fi
  elif need-to-build-index $LATEXDOC ; then
    build-index $LATEXDOC
  else
    break
  fi
done
